package google;

use strict;
use LWP::UserAgent;
use List::MoreUtils qw/uniq/;
use HTML::Entities;
use URI::Escape;

sub run {
	my ($q, $p) = @_;
	my @res = ();
	
	my $ua = LWP::UserAgent->new();
	for (0..$p) {
		$ua->agent('Nokia2610 UCWEB/6.0');
		my $res = $ua->get('http://www.google.com/pda?q='.$q.'&start='.$_.'0');
		if ($res->is_success) {
			my $data = $res->decoded_content;
			$data = decode_entities($data);
			if ($data =~ m#did not match any documents\. </div>#) {
				last;
			}
			while ($data =~ m#href="/url\?q=(.+?)"#g) {
				my $lnk = $1;
				$lnk =~ s#&sa=.+##;
				$lnk = uri_unescape($lnk);
				push @res, $lnk;
			}
		}
	}

	return uniq(@res);
}

1;